#procedure AlgB0(i)
****************************************************************************
**
**  Filename:
**            AlgB0.prc
**
**  Authors: 
**            Sven O. Moch and Peter Uwer
**
**  Purpose: 
**            Special case of the convolution algorithm (type B), 
**            for details see \keyword{AlgB}.
**
**  Comments:
**
**
**  Revision: 
**            $Id: AlgB0.prc,v 1.0 2005/08/02 10:09:54 puwer Exp $
**
**            $Log: AlgB0.prc,v $
**            Revision 1.0  2005/08/02 10:09:54  puwer
**            Initial revision
**
**
****************************************************************************
*
repeat;
	if ( ( count(den`i',1) == 0 ) 
			&& ( match(S`i'(R(?a),X(?x),0,j`i')*S`i'(R(?b),X(?y),n?,-j`i')) ) );
		if ( count(pow`i',1) );
			id  sum`i'(j`i',n2?{,0,1},n?)*pow`i'(y1?,j`i')*
				S`i'(R(n1?,?a),X(x1?,?x),0,j`i')*S`i'(R(?b),X(?y),n?,-j`i') =
				sum`i'(j`i',1,n)*S`i'(R(?a),X(?x),0,j`i')*
				den`i'(n1,0,j`i')*pow`i'(x1,j`i')*theta_(n-1)*
				sum(j,1,n,-j`i')*S`i'(R(?b),X(?y),0,j)*pow(y1,n)*pow`i'(1/y1,j);
		else;
			id  sum`i'(j`i',n2?{,0,1},n?)*
				S`i'(R(n1?,?a),X(x1?,?x),0,j`i')*S`i'(R(?b),X(?y),n?,-j`i') = 
				sum`i'(j`i',1,n)*S`i'(R(?a),X(?x),0,j`i')*
				den`i'(n1,0,j`i')*pow`i'(x1,j`i')*theta_(n-1)*
				sum(j,1,n,-j`i')*S`i'(R(?b),X(?y),0,j);
		endif;
		if ( match(pow`i'(y1?,j)) );
			id  sum(j,1,x2?,-j`i')*S`i'(R(n1?,?a),X(y1?,?y),0,j)*pow`i'(y2?,j) = 
				den(1-y2)*(-pow(y2,x2-j`i'+1)*pow(1/y2,j`i')*
				S(R(n1,?a),X(y1,?y),x2,-j`i')+S(R(n1,?a),X(y1*y2,?y),x2,-j`i'));
		else;
			repeat;
				id  sum(j,1,x2?,-j`i')*S`i'(R(n1?pos_,?a),X(y1?,?y),0,j) = 
					(x2-j`i'+1)*S(R(n1,?a),X(y1,?y),x2,-j`i')
					-sum(j,1,x2,-j`i')*S`i'(R(?a),X(?y),0,j)*pow`i'(y1,j)*delta_(n1-1)
					-S(R(n1-1,?a),X(y1,?y),x2,-j`i')*theta_(n1-2);
				id  pow`i'(1,j) = 1;
				id  sum(j,1,x2?,-j`i')*S`i'(R(n1?,?a),X(y1?,?y),0,j)*pow`i'(y2?,j) = 
					den(1-y2)*(-pow(y2,x2+1)*pow(1/y2,j`i')*S(R(n1,?a),X(y1,?y),x2,-j`i')
					+S(R(n1,?a),X(y1*y2,?y),x2,-j`i'));
			endrepeat;
		endif;
		if ( match(S`i'(R,X,0,j)) );
			id  S`i'(R,X,?a) = 1;
			if ( match(pow`i'(y1?,j)) );
				id  sum(j,1,x2?,-j`i')*pow`i'(y1?,j) = 
					den(1-y1)*(-pow(y1,x2+1)*pow(1/y1,j`i')+pow(y1,1));
			else;
				id  sum(j,1,x2?,-j`i') = x2-j`i';
			endif;
		endif;
		id  S`i'(R,X,?a) = 1;
		id  pow(y1?,0) = 1;
		id  pow`i'(1,j`i') = 1;
		id  pow`i'(x1?,j`i')*pow`i'(y1?,j`i') = pow`i'(x1*y1,j`i');
		id  j`i'*den`i'(n?,0,j`i') = den`i'(n-1,0,j`i');
		id  den`i'(0,0,j`i') = 1;
	endif;
endrepeat;
if ( match(S`i'(R(?a),X(?x),x1?,-j`i')) );
	id  den`i'(x1?,j`i') = den`i'(1,x1,j`i');
	repeat id den`i'(n1?,x1?,j`i')*den`i'(n2?,x1?,j`i') = 
			den`i'(n1+n2,x1,j`i');
	if ( count(den`i',1) == 1 );
		#call AlgB(`i')
	endif;
endif;
id  pow(y1?,n1?)*pow(y1?,n2?) = pow(y1,n1+n2);
#endprocedure
*************************************************************************
* Local variables:
* modify-insert-tag: nil
* comment-start: "*"
* tab-width: 2
* End:
*************************************************************************
