#procedure BasisS(i)
****************************************************************************
**
**  Filename:
**            BasisS.prc
**
**  Authors: 
**            Sven O. Moch and Peter Uwer
**
**  Purpose: 
**            Express products of $S$-sums into single $S$-sums of higher weight.
**
**  Comments:
**            This procedure is a modified version of a similiar procedure 
**            in the Summer package written by J.A.M. Vermaseren.
**
**  Revision: 
**            $Id: BasisS.prc,v 1.0 2005/08/02 10:09:54 puwer Exp $
**
**            $Log: BasisS.prc,v $
**            Revision 1.0  2005/08/02 10:09:54  puwer
**            Initial revision
**
**
****************************************************************************
#if `i' == 0
*
*   No sum taking place.
*
	repeat;
  	id,once S(R(?m1),X(?x1),n?) * S(R(?m2),X(?x2),n?) = 
    	SBasisS(R(?m1),X(?x1),R,X,R(?m2),X(?x2),n);
	  repeat id SBasisS(R(n1?,?m1),X(y1?,?x1),R(?m3),X(?x3),R(n2?,?m2),X(y2?,?x2),n?) = 
  	  SBasisS(R(?m1),X(?x1),R(?m3,n1),X(?x3,y1),R(n2,?m2),X(y2,?x2),n)
    	+ SBasisS(R(n1,?m1),X(y1,?x1),R(?m3,n2),X(?x3,y2),R(?m2),X(?x2),n)
    	- SBasisS(R(?m1),X(?x1),R(?m3,n1+n2),X(?x3,y1*y2),R(?m2),X(?x2),n);
  	id SBasisS(R(?m1),X(?x1),R(?m3),X(?x3),R(?m2),X(?x2),n?) =
    	S(R(?m3,?m1,?m2),X(?x3,?x1,?x2),n);
	endrepeat;
#else
	repeat;
  	id,once S`i'(R(?m1),X(?x1),n?) * S`i'(R(?m2),X(?x2),n?) = 
    	SBasisS(R(?m1),X(?x1),R,X,R(?m2),X(?x2),n);
	  repeat id SBasisS(R(n1?,?m1),X(y1?,?x1),R(?m3),X(?x3),R(n2?,?m2),X(y2?,?x2),n?) = 
  	  SBasisS(R(?m1),X(?x1),R(?m3,n1),X(?x3,y1),R(n2,?m2),X(y2,?x2),n)
    	+ SBasisS(R(n1,?m1),X(y1,?x1),R(?m3,n2),X(?x3,y2),R(?m2),X(?x2),n)
    	- SBasisS(R(?m1),X(?x1),R(?m3,n1+n2),X(?x3,y1*y2),R(?m2),X(?x2),n);
  	id SBasisS(R(?m1),X(?x1),R(?m3),X(?x3),R(?m2),X(?x2),n?) =
    	S`i'(R(?m3,?m1,?m2),X(?x3,?x1,?x2),n);
	endrepeat;
#endif
#endprocedure
*************************************************************************
* Local variables:
* modify-insert-tag: nil
* comment-start: "*"
* tab-width: 2
* End:
*************************************************************************
