#procedure Makej(icounter)
****************************************************************************
**
**  Filename:
**            Makej.prc
**
**  Authors: 
**            Sven O. Moch and Peter Uwer
**
**  Purpose: 
**            Creates the {\it dressed objects}, for example the \keyword{pow}
**            function {\tt pow(x,j3)} is converted to {\tt pow3(x,j3)}. 
**            The argument specifies the summation index to be treated.
**
**  Comments:
**            This procedure is a modified version of a similiar procedure 
**            in the Summer package written by J.A.M. Vermaseren.
**
**
**  Revision: 
**            $Id: Makej.prc,v 1.0 2005/08/02 10:09:54 puwer Exp $
**
**            $Log: Makej.prc,v $
**            Revision 1.0  2005/08/02 10:09:54  puwer
**            Initial revision
**
**
****************************************************************************
id 	S(?x1,j`icounter') = S(?x1,0,j`icounter');
id 	S(?x1,-j`icounter') = S(?x1,0,-j`icounter');
Splitarg,(j`icounter'),S;
id 	S(?x1,j`icounter')  = S`icounter'(?x1,j`icounter');
id 	S(?x1,-j`icounter')  = S`icounter'(?x1,-j`icounter');

SplitArg,((j`icounter')),delta,deltap,theta,fac,invfac;
id  f?{delta,deltap,theta,fac,invfac}(j`icounter') = f(0,j`icounter');
id  f?{delta,deltap,theta,fac,invfac}(-j`icounter') = f(0,-j`icounter');
*
*   create the `icounter' functions
*
id  f?{delta,deltap,theta,fac,invfac}[n](x1?,j`icounter') =
    {delta`icounter',deltap`icounter',theta`icounter',fac`icounter',invfac`icounter'}[n](x1,j`icounter');
id  f?{delta,deltap,theta,fac,invfac}[n](x1?,-j`icounter') =
    {delta`icounter',deltap`icounter',theta`icounter',fac`icounter',invfac`icounter'}[n](x1,-j`icounter');
*
* create the pow`icounter' functions
* convert the pow functions back to standard notation, take out integer powers
*
SplitArg,((j`icounter')),pow;
id 	pow(den(x1?),-j`icounter') = pow`icounter'(x1,j`icounter');
id 	pow(x1?,j`icounter')  = pow`icounter'(x1,j`icounter');
id 	pow(x1?,-j`icounter') = pow`icounter'(1/x1,j`icounter');
id 	pow(den(x1?),m1?,m2?) = pow(x1,-m1) * pow`icounter'(1/x1^(m2/j`icounter'),j`icounter');
id 	pow(x1?,m1?,m2?)  = pow(x1,m1) * pow`icounter'(x1^(m2/j`icounter'),j`icounter');

id pow(den(x1?),m1?) = pow(x1,-m1);
repeat 	id pow(x?,m1?number_) * pow(x?,m2?number_) = pow(x,m1+m2);
repeat 	id pow`icounter'(x1?,j`icounter') * pow`icounter'(x2?,j`icounter') = pow`icounter'(x1*x2,j`icounter');
repeat 	id pow(x?,m1?)*pow(x?,m2?) = pow(x,m1+m2);

id 	bino(n?,j`icounter') = bino`icounter'(n,j`icounter');
id  sum(j`icounter',?a) = sum`icounter'(j`icounter',?a);
id  sign(j`icounter') = sign`icounter'(j`icounter');

#endprocedure
*************************************************************************
* Local variables:
* modify-insert-tag: nil
* comment-start: "*"
* tab-width: 2
* End:
*************************************************************************
