#procedure SimpleArgs(text)
****************************************************************************
**
**  Filename:
**            SimpleArgs.prc
**
**  Authors: 
**            Sven O. Moch and Peter Uwer
**
**  Purpose: 
**            Applies some trivial simplifications. If the argument passed
**            to \keyword{SimpleArgs} is 0 these simplifications are applied to
**            the prefactors multiplying functions. If the argument passed 
**            is C the simplifications are applied to the arguments of
**            \keyword{S} and \keyword{pow} functions. 
**
**  Comments:
**
**
**  Revision: 
**            $Id: SimpleArgs.prc,v 1.0 2005/08/02 10:09:54 puwer Exp $
**
**            $Log: SimpleArgs.prc,v $
**            Revision 1.0  2005/08/02 10:09:54  puwer
**            Initial revision
**
**
****************************************************************************
*
#if `text' = 0

id num(x?)*den(x?) = 1;
#do i = `MAXCOUNTER',1,-1
SplitArg,((x`i')),den,num;
id num(y?,+x`i') = num(y) + num(x`i');
id num(y?,-x`i') = num(y) - num(x`i');
id den(y1?,-x`i') = den(-y1,x`i');
repeat id num(x`i')*den(y1?,+x`i') = 1 - num(y1)*den(y1,x`i');
repeat id x`i'*den(y1?,+x`i') = 1 - num(y1)*den(y1,x`i');
id num(x?int_) = x;
#enddo

#elseif `text' = C

Argument,S,pow;
id num(x?)*den(x?) = 1;
#do i = `MAXCOUNTER',1,-1
SplitArg,((x`i')),den,num;
id num(y?,+x`i') = num(y) + num(x`i');
id num(y?,-x`i') = num(y) - num(x`i');
id den(y1?,-x`i') = den(-y1,x`i');
repeat id num(x`i')*den(y1?,+x`i') = 1 - num(y1)*den(y1,x`i');
repeat id x`i'*den(y1?,+x`i') = 1 - num(y1)*den(y1,x`i');
id num(x?int_) = x;
#enddo

Argument, XX,X;
 id num(x?)*den(x?) = 1;
 id den(x?int_) = 1/x;
 id num(x?) = x;
EndArgument;
EndArgument;

#endif

#endprocedure
*************************************************************************
* Local variables:
* modify-insert-tag: nil
* comment-start: "*"
* tab-width: 2
* End:
*************************************************************************
