#procedure SimplifyFacGam
****************************************************************************
**
**  Filename:
**            SimplifyFacGam
**
**  Authors: 
**            Sven O. Moch and Peter Uwer
**
**  Purpose: 
**            Procedure to simplify  products of \keyword{fac}, \keyword{invfac} 
**            and \keyword{Gamma}, \keyword{InvGamma} functions.
**
**  Comments:
**
**
**  Revision: 
**            $Id: SimplifyFacGam.prc,v 1.0 2005/08/02 10:09:54 puwer Exp $
**
**            $Log: SimplifyFacGam.prc,v $
**            Revision 1.0  2005/08/02 10:09:54  puwer
**            Initial revision
**
**
****************************************************************************
*
*
*
* (1) move factorials onto each other
*
id  fac_(x?) = fac(x);
id  invfac_(x?) = invfac(x);
id  fac(x?)*invfac(x?) = 1;
repeat;
    id,once,fac(x?) = faca(x);
    repeat;
        id  faca(x1?)*invfac(x2?) = faca(x1,x2,x1-x2);
        id  faca(x1?,x2?,x3?int_) = poch(x1,x3);
        id  faca(x1?,x2?,x3?) = faca(x1)*invfaca(x2);
    endrepeat;
    id  invfaca(x?) = invfac(x);
    id  faca(x?) = facb(x);
endrepeat;
repeat id poch(x1?,x2?pos_) = poch(x1-1,x2-1)*num(x1);
repeat id poch(x1?,x2?neg_) = poch(x1+1,x2+1)*den(x1+1);
id  poch(x1?,0) = 1;
id  num(x?)*den(x?) = 1;
id  facb(x?) = fac(x);

*
* (2) move Gamma functions onto each other
*
#do counter = `MAXSUM',1,-1
SplitArg,((j`counter')),Gamma,InvGamma;
repeat;
id,once,Gamma(x?,j`counter') = Gammaa(x,j`counter');
repeat;
      id      Gammaa(x1?,j`counter')*InvGamma(x2?,j`counter') = Gammaa(x1,x2,x2-x1,j`counter');
      repeat id  Gammaa(x1?,x2?,x3?pos_,j`counter') = Gammaa(x1+1,x2,x3-1,j`counter')
                                      *den(x1+j`counter');
      repeat id  Gammaa(x1?,x2?,x3?neg_,j`counter') = Gammaa(x1,x2+1,x3+1,j`counter')
                                      *num(x2+j`counter');
      id      Gammaa(x1?,x1?,0,j`counter') = 1;
      id      Gammaa(x1?,x2?,x3?,j`counter') = Gammaa(x1,j`counter')*InvGammab(x2,j`counter');
endrepeat;
id  InvGammab(x?,j`counter') = InvGamma(x,j`counter');
id  Gammaa(x?,j`counter') = Gammab(x,j`counter');
endrepeat;
repeat;
id,once,Gamma(x?,-j`counter') = Gammaa(x,-j`counter');
repeat;
      id      Gammaa(x1?,-j`counter')*InvGamma(x2?,-j`counter') = Gammaa(x1,x2,x2-x1,-j`counter');
      repeat id  Gammaa(x1?,x2?,x3?pos_,-j`counter') = -Gammaa(x1+1,x2,x3-1,-j`counter')
                                      *den(-x1+j`counter');
      repeat id  Gammaa(x1?,x2?,x3?neg_,-j`counter') = Gammaa(x1,x2+1,x3+1,-j`counter')
                                      *num(x2-j`counter');
      id      Gammaa(x1?,x1?,0,-j`counter') = 1;
      id      Gammaa(x1?,x2?,x3?,-j`counter') = Gammaa(x1,-j`counter')*InvGammab(x2,-j`counter');
endrepeat;
id  InvGammab(x?,-j`counter') = InvGamma(x,-j`counter');
id  Gammaa(x?,-j`counter') = Gammab(x,-j`counter');
endrepeat;
id  Gammab(?a) =  Gamma(?a);
id  InvGammab(?a) =  InvGamma(?a);
id  Gamma(x1?,x2?) = Gamma(x1+x2);
id  InvGamma(x1?,x2?) = InvGamma(x1+x2);
.sort: Gamma(`counter');
#enddo

#endprocedure
*
*************************************************************************
* Local variables:
* modify-insert-tag: nil
* comment-start: "*"
* tab-width: 2
* End:
*************************************************************************
